(function(root, factory) {
  if (typeof define === 'function' && define.amd) 
    define(['exports', 'kotlin', 'kotlinx-coroutines-core', 'ktor-ktor-io-jsLegacy', 'ktor-ktor-utils-jsLegacy'], factory);
  else if (typeof exports === 'object') 
    factory(module.exports, require('kotlin'), require('kotlinx-coroutines-core'), require('ktor-ktor-io-jsLegacy'), require('ktor-ktor-utils-jsLegacy'));
  else {
    if (typeof kotlin === 'undefined') {
      throw new Error("Error loading module 'ktor-ktor-network-jsLegacy'. Its dependency 'kotlin' was not found. Please, check whether 'kotlin' is loaded prior to 'ktor-ktor-network-jsLegacy'.");
    }
    if (typeof this['kotlinx-coroutines-core'] === 'undefined') {
      throw new Error("Error loading module 'ktor-ktor-network-jsLegacy'. Its dependency 'kotlinx-coroutines-core' was not found. Please, check whether 'kotlinx-coroutines-core' is loaded prior to 'ktor-ktor-network-jsLegacy'.");
    }
    if (typeof this['ktor-ktor-io-jsLegacy'] === 'undefined') {
      throw new Error("Error loading module 'ktor-ktor-network-jsLegacy'. Its dependency 'ktor-ktor-io-jsLegacy' was not found. Please, check whether 'ktor-ktor-io-jsLegacy' is loaded prior to 'ktor-ktor-network-jsLegacy'.");
    }
    if (typeof this['ktor-ktor-utils-jsLegacy'] === 'undefined') {
      throw new Error("Error loading module 'ktor-ktor-network-jsLegacy'. Its dependency 'ktor-ktor-utils-jsLegacy' was not found. Please, check whether 'ktor-ktor-utils-jsLegacy' is loaded prior to 'ktor-ktor-network-jsLegacy'.");
    }
    root['ktor-ktor-network-jsLegacy'] = factory(typeof this['ktor-ktor-network-jsLegacy'] === 'undefined' ? {} : this['ktor-ktor-network-jsLegacy'], kotlin, this['kotlinx-coroutines-core'], this['ktor-ktor-io-jsLegacy'], this['ktor-ktor-utils-jsLegacy']);
  }
}(this, function(_, Kotlin, $module$kotlinx_coroutines_core, $module$ktor_ktor_io_jsLegacy, $module$ktor_ktor_utils_jsLegacy) {
  'use strict';
  var CancellationException_init = $module$kotlinx_coroutines_core.kotlinx.coroutines.CancellationException_init_pdl1vj$;
  var Kind_CLASS = Kotlin.Kind.CLASS;
  var CancellationException = $module$kotlinx_coroutines_core.kotlinx.coroutines.CancellationException;
  var Unit = Kotlin.kotlin.Unit;
  var throwCCE = Kotlin.throwCCE;
  var Kind_INTERFACE = Kotlin.Kind.INTERFACE;
  var COROUTINE_SUSPENDED = Kotlin.kotlin.coroutines.intrinsics.COROUTINE_SUSPENDED;
  var CoroutineImpl = Kotlin.kotlin.coroutines.CoroutineImpl;
  var IllegalArgumentException_init = Kotlin.kotlin.IllegalArgumentException_init_pdl1vj$;
  var Long$Companion$MAX_VALUE = Kotlin.Long.MAX_VALUE;
  var HashMap_init = Kotlin.kotlin.collections.HashMap_init_73mtqc$;
  var HashMap_init_0 = Kotlin.kotlin.collections.HashMap_init_q3lmfv$;
  var Kind_OBJECT = Kotlin.Kind.OBJECT;
  var Throwable = Error;
  var Closeable = $module$ktor_ktor_io_jsLegacy.io.ktor.utils.io.core.Closeable;
  var DisposableHandle = $module$kotlinx_coroutines_core.kotlinx.coroutines.DisposableHandle;
  var ByteChannel = $module$ktor_ktor_io_jsLegacy.io.ktor.utils.io.ByteChannel_6taknv$;
  var NetworkAddress = $module$ktor_ktor_utils_jsLegacy.io.ktor.util.network.NetworkAddress_bm4lxs$;
  var defineInlineFunction = Kotlin.defineInlineFunction;
  var UByte = Kotlin.kotlin.UByte;
  var toByte = Kotlin.toByte;
  var coroutines = Kotlin.kotlin.coroutines;
  var CoroutineScope = $module$kotlinx_coroutines_core.kotlinx.coroutines.CoroutineScope;
  var Enum = Kotlin.kotlin.Enum;
  var throwISE = Kotlin.throwISE;
  var IllegalStateException_init = Kotlin.kotlin.IllegalStateException_init_pdl1vj$;
  var IOException_init = $module$ktor_ktor_io_jsLegacy.io.ktor.utils.io.errors.IOException_init_61zpoe$;
  var IOException = $module$ktor_ktor_io_jsLegacy.io.ktor.utils.io.errors.IOException;
  ClosedChannelCancellationException.prototype = Object.create(CancellationException.prototype);
  ClosedChannelCancellationException.prototype.constructor = ClosedChannelCancellationException;
  SocketOptions$GeneralSocketOptions.prototype = Object.create(SocketOptions.prototype);
  SocketOptions$GeneralSocketOptions.prototype.constructor = SocketOptions$GeneralSocketOptions;
  SocketOptions$AcceptorOptions.prototype = Object.create(SocketOptions.prototype);
  SocketOptions$AcceptorOptions.prototype.constructor = SocketOptions$AcceptorOptions;
  SocketOptions$PeerSocketOptions.prototype = Object.create(SocketOptions.prototype);
  SocketOptions$PeerSocketOptions.prototype.constructor = SocketOptions$PeerSocketOptions;
  SocketOptions$UDPSocketOptions.prototype = Object.create(SocketOptions$PeerSocketOptions.prototype);
  SocketOptions$UDPSocketOptions.prototype.constructor = SocketOptions$UDPSocketOptions;
  SocketOptions$TCPClientSocketOptions.prototype = Object.create(SocketOptions$PeerSocketOptions.prototype);
  SocketOptions$TCPClientSocketOptions.prototype.constructor = SocketOptions$TCPClientSocketOptions;
  SelectInterest.prototype = Object.create(Enum.prototype);
  SelectInterest.prototype.constructor = SelectInterest;
  SocketTimeoutException.prototype = Object.create(IOException.prototype);
  SocketTimeoutException.prototype.constructor = SocketTimeoutException;
  function ClosedChannelCancellationException() {
    CancellationException_init('Closed channel.', this);
    this.name = 'ClosedChannelCancellationException';
  }
  ClosedChannelCancellationException.$metadata$ = {
  kind: Kind_CLASS, 
  simpleName: 'ClosedChannelCancellationException', 
  interfaces: [CancellationException]};
  function aSocket(selector) {
    return new SocketBuilder(selector, SocketOptions$Companion_getInstance().create_8be2vx$());
  }
  function SocketBuilder(selector, options) {
    this.selector_0 = selector;
    this.options_lil4kq$_0 = options;
  }
  Object.defineProperty(SocketBuilder.prototype, 'options', {
  get: function() {
  return this.options_lil4kq$_0;
}, 
  set: function(options) {
  this.options_lil4kq$_0 = options;
}});
  SocketBuilder.prototype.tcp = function() {
  return new TcpSocketBuilder(this.selector_0, this.options.peer_8be2vx$());
};
  SocketBuilder.prototype.udp = function() {
  return new UDPSocketBuilder(this.selector_0, this.options.peer_8be2vx$().udp_8be2vx$());
};
  SocketBuilder.$metadata$ = {
  kind: Kind_CLASS, 
  simpleName: 'SocketBuilder', 
  interfaces: [Configurable]};
  function tcpNoDelay$lambda($receiver) {
    if (Kotlin.isType($receiver, SocketOptions$TCPClientSocketOptions)) {
      $receiver.noDelay = true;
    }
    return Unit;
  }
  function tcpNoDelay($receiver) {
    return $receiver.configure_ahbkwy$(tcpNoDelay$lambda);
  }
  function Configurable() {
  }
  Configurable.prototype.configure_ahbkwy$ = function(block) {
  var tmp$, tmp$_0;
  var newOptions = Kotlin.isType(tmp$ = this.options.copy(), SocketOptions) ? tmp$ : throwCCE();
  block(newOptions);
  this.options = newOptions;
  return Kotlin.isType(tmp$_0 = this, Configurable) ? tmp$_0 : throwCCE();
};
  Configurable.$metadata$ = {
  kind: Kind_INTERFACE, 
  simpleName: 'Configurable', 
  interfaces: []};
  var MAX_DATAGRAM_SIZE;
  function Datagram(packet, address) {
    this.packet = packet;
    this.address = address;
    if (!(this.packet.remaining.toNumber() <= 65535)) {
      var message = 'Datagram size limit exceeded: ' + this.packet.remaining.toString() + ' of possible ' + '65535';
      throw IllegalArgumentException_init(message.toString());
    }
  }
  Datagram.$metadata$ = {
  kind: Kind_CLASS, 
  simpleName: 'Datagram', 
  interfaces: []};
  function DatagramWriteChannel() {
  }
  function Coroutine$send_wa0s53$($this, datagram_0, continuation_0) {
    CoroutineImpl.call(this, continuation_0);
    this.exceptionState_0 = 1;
    this.$this = $this;
    this.local$datagram = datagram_0;
  }
  Coroutine$send_wa0s53$.$metadata$ = {
  kind: Kotlin.Kind.CLASS, 
  simpleName: null, 
  interfaces: [CoroutineImpl]};
  Coroutine$send_wa0s53$.prototype = Object.create(CoroutineImpl.prototype);
  Coroutine$send_wa0s53$.prototype.constructor = Coroutine$send_wa0s53$;
  Coroutine$send_wa0s53$.prototype.doResume = function() {
  do try {
    switch (this.state_0) {
      case 0:
        this.state_0 = 2;
        this.result_0 = this.$this.outgoing.send_11rb$(this.local$datagram, this);
        if (this.result_0 === COROUTINE_SUSPENDED) 
          return COROUTINE_SUSPENDED;
        continue;
      case 1:
        throw this.exception_0;
      case 2:
        return;
      default:
        this.state_0 = 1;
        throw new Error('State Machine Unreachable execution');
    }
  }  catch (e) {
  if (this.state_0 === 1) {
    this.exceptionState_0 = this.state_0;
    throw e;
  } else {
    this.state_0 = this.exceptionState_0;
    this.exception_0 = e;
  }
} while (true);
};
  DatagramWriteChannel.prototype.send_wa0s53$ = function(datagram_0, continuation_0, suspended) {
  var instance = new Coroutine$send_wa0s53$(this, datagram_0, continuation_0);
  if (suspended) 
    return instance;
  else 
    return instance.doResume(null);
};
  DatagramWriteChannel.$metadata$ = {
  kind: Kind_INTERFACE, 
  simpleName: 'DatagramWriteChannel', 
  interfaces: []};
  function DatagramReadChannel() {
  }
  DatagramReadChannel.prototype.receive = function(continuation) {
  return this.incoming.receive(continuation);
};
  DatagramReadChannel.$metadata$ = {
  kind: Kind_INTERFACE, 
  simpleName: 'DatagramReadChannel', 
  interfaces: []};
  function DatagramReadWriteChannel() {
  }
  DatagramReadWriteChannel.$metadata$ = {
  kind: Kind_INTERFACE, 
  simpleName: 'DatagramReadWriteChannel', 
  interfaces: [DatagramWriteChannel, DatagramReadChannel]};
  function BoundDatagramSocket() {
  }
  BoundDatagramSocket.$metadata$ = {
  kind: Kind_INTERFACE, 
  simpleName: 'BoundDatagramSocket', 
  interfaces: [DatagramReadWriteChannel, AReadable, ABoundSocket, ASocket]};
  function ConnectedDatagramSocket() {
  }
  ConnectedDatagramSocket.$metadata$ = {
  kind: Kind_INTERFACE, 
  simpleName: 'ConnectedDatagramSocket', 
  interfaces: [DatagramReadWriteChannel, ReadWriteSocket, AConnectedSocket, ABoundSocket, ASocket]};
  var INFINITE_TIMEOUT_MS;
  function SocketOptions(customOptions) {
    SocketOptions$Companion_getInstance();
    this.customOptions = customOptions;
    this.typeOfService = TypeOfService$Companion_getInstance().UNDEFINED;
    this.reuseAddress = false;
    this.reusePort = false;
  }
  SocketOptions.prototype.copyCommon_72ks9v$ = function(from) {
  this.typeOfService = from.typeOfService;
  this.reuseAddress = from.reuseAddress;
  this.reusePort = from.reusePort;
};
  SocketOptions.prototype.peer_8be2vx$ = function() {
  var $receiver = new SocketOptions$PeerSocketOptions(HashMap_init(this.customOptions));
  this.copyCommon_72ks9v$(this);
  return $receiver;
};
  SocketOptions.prototype.acceptor_8be2vx$ = function() {
  var $receiver = new SocketOptions$AcceptorOptions(HashMap_init(this.customOptions));
  $receiver.copyCommon_72ks9v$(this);
  return $receiver;
};
  function SocketOptions$GeneralSocketOptions(customOptions) {
    SocketOptions.call(this, customOptions);
  }
  SocketOptions$GeneralSocketOptions.prototype.copy = function() {
  var $receiver = new SocketOptions$GeneralSocketOptions(HashMap_init(this.customOptions));
  $receiver.copyCommon_72ks9v$(this);
  return $receiver;
};
  SocketOptions$GeneralSocketOptions.$metadata$ = {
  kind: Kind_CLASS, 
  simpleName: 'GeneralSocketOptions', 
  interfaces: [SocketOptions]};
  function SocketOptions$AcceptorOptions(customOptions) {
    SocketOptions.call(this, customOptions);
    this.backlogSize = 511;
  }
  SocketOptions$AcceptorOptions.prototype.copy = function() {
  var $receiver = new SocketOptions$AcceptorOptions(HashMap_init(this.customOptions));
  $receiver.copyCommon_72ks9v$(this);
  return $receiver;
};
  SocketOptions$AcceptorOptions.$metadata$ = {
  kind: Kind_CLASS, 
  simpleName: 'AcceptorOptions', 
  interfaces: [SocketOptions]};
  function SocketOptions$PeerSocketOptions(customOptions) {
    SocketOptions.call(this, customOptions);
    this.sendBufferSize = -1;
    this.receiveBufferSize = -1;
  }
  SocketOptions$PeerSocketOptions.prototype.copyCommon_72ks9v$ = function(from) {
  SocketOptions.prototype.copyCommon_72ks9v$.call(this, from);
  if (Kotlin.isType(from, SocketOptions$PeerSocketOptions)) {
    this.sendBufferSize = from.sendBufferSize;
    this.receiveBufferSize = from.receiveBufferSize;
  }
};
  SocketOptions$PeerSocketOptions.prototype.copy = function() {
  var $receiver = new SocketOptions$PeerSocketOptions(HashMap_init(this.customOptions));
  $receiver.copyCommon_72ks9v$(this);
  return $receiver;
};
  SocketOptions$PeerSocketOptions.prototype.tcp_8be2vx$ = function() {
  var $receiver = new SocketOptions$TCPClientSocketOptions(HashMap_init(this.customOptions));
  this.copyCommon_72ks9v$(this);
  return $receiver;
};
  SocketOptions$PeerSocketOptions.prototype.udp_8be2vx$ = function() {
  var $receiver = new SocketOptions$UDPSocketOptions(HashMap_init(this.customOptions));
  this.copyCommon_72ks9v$(this);
  return $receiver;
};
  SocketOptions$PeerSocketOptions.$metadata$ = {
  kind: Kind_CLASS, 
  simpleName: 'PeerSocketOptions', 
  interfaces: [SocketOptions]};
  function SocketOptions$UDPSocketOptions(customOptions) {
    SocketOptions$PeerSocketOptions.call(this, customOptions);
    this.broadcast = false;
  }
  SocketOptions$UDPSocketOptions.prototype.copyCommon_72ks9v$ = function(from) {
  SocketOptions$PeerSocketOptions.prototype.copyCommon_72ks9v$.call(this, from);
  if (Kotlin.isType(from, SocketOptions$UDPSocketOptions)) {
    this.broadcast = from.broadcast;
  }
};
  SocketOptions$UDPSocketOptions.prototype.copy = function() {
  var $receiver = new SocketOptions$UDPSocketOptions(HashMap_init(this.customOptions));
  $receiver.copyCommon_72ks9v$(this);
  return $receiver;
};
  SocketOptions$UDPSocketOptions.$metadata$ = {
  kind: Kind_CLASS, 
  simpleName: 'UDPSocketOptions', 
  interfaces: [SocketOptions$PeerSocketOptions]};
  function SocketOptions$TCPClientSocketOptions(customOptions) {
    SocketOptions$PeerSocketOptions.call(this, customOptions);
    this.noDelay = true;
    this.lingerSeconds = -1;
    this.keepAlive = null;
    this.socketTimeout = INFINITE_TIMEOUT_MS;
  }
  SocketOptions$TCPClientSocketOptions.prototype.copyCommon_72ks9v$ = function(from) {
  SocketOptions$PeerSocketOptions.prototype.copyCommon_72ks9v$.call(this, from);
  if (Kotlin.isType(from, SocketOptions$TCPClientSocketOptions)) {
    this.noDelay = from.noDelay;
    this.lingerSeconds = from.lingerSeconds;
    this.keepAlive = from.keepAlive;
  }
};
  SocketOptions$TCPClientSocketOptions.prototype.copy = function() {
  var $receiver = new SocketOptions$TCPClientSocketOptions(HashMap_init(this.customOptions));
  $receiver.copyCommon_72ks9v$(this);
  return $receiver;
};
  SocketOptions$TCPClientSocketOptions.$metadata$ = {
  kind: Kind_CLASS, 
  simpleName: 'TCPClientSocketOptions', 
  interfaces: [SocketOptions$PeerSocketOptions]};
  function SocketOptions$Companion() {
    SocketOptions$Companion_instance = this;
  }
  SocketOptions$Companion.prototype.create_8be2vx$ = function() {
  return new SocketOptions$GeneralSocketOptions(HashMap_init_0());
};
  SocketOptions$Companion.$metadata$ = {
  kind: Kind_OBJECT, 
  simpleName: 'Companion', 
  interfaces: []};
  var SocketOptions$Companion_instance = null;
  function SocketOptions$Companion_getInstance() {
    if (SocketOptions$Companion_instance === null) {
      new SocketOptions$Companion();
    }
    return SocketOptions$Companion_instance;
  }
  SocketOptions.$metadata$ = {
  kind: Kind_CLASS, 
  simpleName: 'SocketOptions', 
  interfaces: []};
  function ASocket() {
  }
  ASocket.prototype.dispose = function() {
  try {
    this.close();
  }  catch (ignore) {
  if (!Kotlin.isType(ignore, Throwable)) 
    throw ignore;
}
};
  ASocket.$metadata$ = {
  kind: Kind_INTERFACE, 
  simpleName: 'ASocket', 
  interfaces: [DisposableHandle, Closeable]};
  function get_isClosed($receiver) {
    return $receiver.socketContext.isCompleted;
  }
  function Coroutine$awaitClosed($receiver_0, continuation_0) {
    CoroutineImpl.call(this, continuation_0);
    this.exceptionState_0 = 1;
    this.local$$receiver = $receiver_0;
  }
  Coroutine$awaitClosed.$metadata$ = {
  kind: Kotlin.Kind.CLASS, 
  simpleName: null, 
  interfaces: [CoroutineImpl]};
  Coroutine$awaitClosed.prototype = Object.create(CoroutineImpl.prototype);
  Coroutine$awaitClosed.prototype.constructor = Coroutine$awaitClosed;
  Coroutine$awaitClosed.prototype.doResume = function() {
  do try {
    switch (this.state_0) {
      case 0:
        this.state_0 = 2;
        this.result_0 = this.local$$receiver.socketContext.join(this);
        if (this.result_0 === COROUTINE_SUSPENDED) 
          return COROUTINE_SUSPENDED;
        continue;
      case 1:
        throw this.exception_0;
      case 2:
        if (this.local$$receiver.socketContext.isCancelled) 
          throw this.local$$receiver.socketContext.getCancellationException();
        return;
      default:
        this.state_0 = 1;
        throw new Error('State Machine Unreachable execution');
    }
  }  catch (e) {
  if (this.state_0 === 1) {
    this.exceptionState_0 = this.state_0;
    throw e;
  } else {
    this.state_0 = this.exceptionState_0;
    this.exception_0 = e;
  }
} while (true);
};
  function awaitClosed($receiver_0, continuation_0, suspended) {
    var instance = new Coroutine$awaitClosed($receiver_0, continuation_0);
    if (suspended) 
      return instance;
    else 
      return instance.doResume(null);
  }
  function AConnectedSocket() {
  }
  AConnectedSocket.$metadata$ = {
  kind: Kind_INTERFACE, 
  simpleName: 'AConnectedSocket', 
  interfaces: [AWritable]};
  function ABoundSocket() {
  }
  ABoundSocket.$metadata$ = {
  kind: Kind_INTERFACE, 
  simpleName: 'ABoundSocket', 
  interfaces: []};
  function Acceptable() {
  }
  Acceptable.$metadata$ = {
  kind: Kind_INTERFACE, 
  simpleName: 'Acceptable', 
  interfaces: [ASocket]};
  function AReadable() {
  }
  AReadable.$metadata$ = {
  kind: Kind_INTERFACE, 
  simpleName: 'AReadable', 
  interfaces: []};
  function AWritable() {
  }
  AWritable.$metadata$ = {
  kind: Kind_INTERFACE, 
  simpleName: 'AWritable', 
  interfaces: []};
  function ReadWriteSocket() {
  }
  ReadWriteSocket.$metadata$ = {
  kind: Kind_INTERFACE, 
  simpleName: 'ReadWriteSocket', 
  interfaces: [AWritable, AReadable, ASocket]};
  function openReadChannel($receiver) {
    var $receiver_0 = ByteChannel(false);
    $receiver.attachForReading_4b1yza$($receiver_0);
    return $receiver_0;
  }
  function openWriteChannel($receiver, autoFlush) {
    if (autoFlush === void 0) 
      autoFlush = false;
    var $receiver_0 = ByteChannel(autoFlush);
    $receiver.attachForWriting_4b1yza$($receiver_0);
    return $receiver_0;
  }
  function Socket() {
  }
  Socket.$metadata$ = {
  kind: Kind_INTERFACE, 
  simpleName: 'Socket', 
  interfaces: [AConnectedSocket, ABoundSocket, ReadWriteSocket]};
  function ServerSocket() {
  }
  ServerSocket.$metadata$ = {
  kind: Kind_INTERFACE, 
  simpleName: 'ServerSocket', 
  interfaces: [Acceptable, ABoundSocket, ASocket]};
  function Connection(socket, input, output) {
    this.socket = socket;
    this.input = input;
    this.output = output;
  }
  Connection.$metadata$ = {
  kind: Kind_CLASS, 
  simpleName: 'Connection', 
  interfaces: []};
  function connection($receiver) {
    return new Connection($receiver, openReadChannel($receiver), openWriteChannel($receiver));
  }
  function TcpSocketBuilder(selector, options) {
    this.selector_0 = selector;
    this.options_22rdr9$_0 = options;
  }
  Object.defineProperty(TcpSocketBuilder.prototype, 'options', {
  get: function() {
  return this.options_22rdr9$_0;
}, 
  set: function(options) {
  this.options_22rdr9$_0 = options;
}});
  function TcpSocketBuilder$connect$lambda($receiver) {
    return Unit;
  }
  TcpSocketBuilder.prototype.connect_799zld$ = function(hostname, port, configure, continuation) {
  if (configure === void 0) 
    configure = TcpSocketBuilder$connect$lambda;
  return this.connect_xm1u9l$(NetworkAddress(hostname, port), configure, continuation);
};
  function TcpSocketBuilder$bind$lambda($receiver) {
    return Unit;
  }
  TcpSocketBuilder.prototype.bind_ghm4xn$ = function(hostname, port, configure) {
  if (hostname === void 0) 
    hostname = '0.0.0.0';
  if (port === void 0) 
    port = 0;
  if (configure === void 0) 
    configure = TcpSocketBuilder$bind$lambda;
  return this.bind_svv1w2$(NetworkAddress(hostname, port), configure);
};
  function TcpSocketBuilder$connect$lambda_0($receiver) {
    return Unit;
  }
  TcpSocketBuilder.prototype.connect_xm1u9l$ = function(remoteAddress, configure, continuation) {
  if (configure === void 0) 
    configure = TcpSocketBuilder$connect$lambda_0;
  var tmp$ = this.selector_0;
  var $receiver = this.options.peer_8be2vx$().tcp_8be2vx$();
  configure($receiver);
  return connect(tmp$, remoteAddress, $receiver, continuation);
};
  function TcpSocketBuilder$bind$lambda_0($receiver) {
    return Unit;
  }
  TcpSocketBuilder.prototype.bind_svv1w2$ = function(localAddress, configure) {
  if (localAddress === void 0) 
    localAddress = null;
  if (configure === void 0) 
    configure = TcpSocketBuilder$bind$lambda_0;
  var tmp$ = this.selector_0;
  var $receiver = this.options.peer_8be2vx$().acceptor_8be2vx$();
  configure($receiver);
  return bind(tmp$, localAddress, $receiver);
};
  TcpSocketBuilder.$metadata$ = {
  kind: Kind_CLASS, 
  simpleName: 'TcpSocketBuilder', 
  interfaces: [Configurable]};
  function TypeOfService(value) {
    TypeOfService$Companion_getInstance();
    this.value = value;
  }
  Object.defineProperty(TypeOfService.prototype, 'intValue', {
  configurable: true, 
  get: defineInlineFunction('ktor-ktor-network-jsLegacy.io.ktor.network.sockets.TypeOfService.get_intValue', function() {
  return this.value.data & 255;
})});
  function TypeOfService$Companion() {
    TypeOfService$Companion_instance = this;
    this.UNDEFINED = new TypeOfService(new UByte(0));
    this.IPTOS_LOWCOST = new TypeOfService(new UByte(2));
    this.IPTOS_RELIABILITY = new TypeOfService(new UByte(4));
    this.IPTOS_THROUGHPUT = new TypeOfService(new UByte(8));
    this.IPTOS_LOWDELAY = new TypeOfService(new UByte(16));
  }
  TypeOfService$Companion.$metadata$ = {
  kind: Kind_OBJECT, 
  simpleName: 'Companion', 
  interfaces: []};
  var TypeOfService$Companion_instance = null;
  function TypeOfService$Companion_getInstance() {
    if (TypeOfService$Companion_instance === null) {
      new TypeOfService$Companion();
    }
    return TypeOfService$Companion_instance;
  }
  TypeOfService.$metadata$ = {
  kind: Kind_CLASS, 
  simpleName: 'TypeOfService', 
  interfaces: []};
  function TypeOfService_init(value, $this) {
    $this = $this || Object.create(TypeOfService.prototype);
    TypeOfService.call($this, new UByte(toByte(value)));
    return $this;
  }
  TypeOfService.prototype.unbox = function() {
  return this.value;
};
  TypeOfService.prototype.toString = function() {
  return 'TypeOfService(value=' + Kotlin.toString(this.value) + ')';
};
  TypeOfService.prototype.hashCode = function() {
  var result = 0;
  result = result * 31 + Kotlin.hashCode(this.value) | 0;
  return result;
};
  TypeOfService.prototype.equals = function(other) {
  return this === other || (other !== null && (typeof other === 'object' && (Object.getPrototypeOf(this) === Object.getPrototypeOf(other) && Kotlin.equals(this.value, other.value))));
};
  function UDPSocketBuilder(selector, options) {
    UDPSocketBuilder$Companion_getInstance();
    this.selector_0 = selector;
    this.options_ljytfp$_0 = options;
  }
  Object.defineProperty(UDPSocketBuilder.prototype, 'options', {
  get: function() {
  return this.options_ljytfp$_0;
}, 
  set: function(options) {
  this.options_ljytfp$_0 = options;
}});
  function UDPSocketBuilder$bind$lambda($receiver) {
    return Unit;
  }
  UDPSocketBuilder.prototype.bind_3ml96r$ = function(localAddress, configure) {
  if (localAddress === void 0) 
    localAddress = null;
  if (configure === void 0) 
    configure = UDPSocketBuilder$bind$lambda;
  var tmp$ = UDPSocketBuilder$Companion_getInstance();
  var tmp$_0 = this.selector_0;
  var $receiver = this.options.udp_8be2vx$();
  configure($receiver);
  return bindUDP(tmp$, tmp$_0, localAddress, $receiver);
};
  function UDPSocketBuilder$connect$lambda($receiver) {
    return Unit;
  }
  UDPSocketBuilder.prototype.connect_o3kmr3$ = function(remoteAddress, localAddress, configure) {
  if (localAddress === void 0) 
    localAddress = null;
  if (configure === void 0) 
    configure = UDPSocketBuilder$connect$lambda;
  var tmp$ = UDPSocketBuilder$Companion_getInstance();
  var tmp$_0 = this.selector_0;
  var $receiver = this.options.udp_8be2vx$();
  configure($receiver);
  return connectUDP(tmp$, tmp$_0, remoteAddress, localAddress, $receiver);
};
  function UDPSocketBuilder$Companion() {
    UDPSocketBuilder$Companion_instance = this;
  }
  UDPSocketBuilder$Companion.$metadata$ = {
  kind: Kind_OBJECT, 
  simpleName: 'Companion', 
  interfaces: []};
  var UDPSocketBuilder$Companion_instance = null;
  function UDPSocketBuilder$Companion_getInstance() {
    if (UDPSocketBuilder$Companion_instance === null) {
      new UDPSocketBuilder$Companion();
    }
    return UDPSocketBuilder$Companion_instance;
  }
  UDPSocketBuilder.$metadata$ = {
  kind: Kind_CLASS, 
  simpleName: 'UDPSocketBuilder', 
  interfaces: [Configurable]};
  function Selectable() {
  }
  Selectable.$metadata$ = {
  kind: Kind_INTERFACE, 
  simpleName: 'Selectable', 
  interfaces: []};
  function SelectorManager(dispatcher) {
    if (dispatcher === void 0) 
      dispatcher = coroutines.EmptyCoroutineContext;
    throw IllegalStateException_init('Selector manager is unsupported on JS platform'.toString());
  }
  function SelectorManager_0() {
    SelectorManager$Companion_getInstance();
  }
  function SelectorManager$Companion() {
    SelectorManager$Companion_instance = this;
  }
  SelectorManager$Companion.$metadata$ = {
  kind: Kind_OBJECT, 
  simpleName: 'Companion', 
  interfaces: []};
  var SelectorManager$Companion_instance = null;
  function SelectorManager$Companion_getInstance() {
    if (SelectorManager$Companion_instance === null) {
      new SelectorManager$Companion();
    }
    return SelectorManager$Companion_instance;
  }
  SelectorManager_0.$metadata$ = {
  kind: Kind_INTERFACE, 
  simpleName: 'SelectorManager', 
  interfaces: [Closeable, CoroutineScope]};
  function SelectInterest(name, ordinal) {
    Enum.call(this);
    this.name$ = name;
    this.ordinal$ = ordinal;
  }
  function SelectInterest_initFields() {
    SelectInterest_initFields = function() {
};
    SelectInterest$READ_instance = new SelectInterest('READ', 0);
    SelectInterest$WRITE_instance = new SelectInterest('WRITE', 1);
    SelectInterest$ACCEPT_instance = new SelectInterest('ACCEPT', 2);
    SelectInterest$CONNECT_instance = new SelectInterest('CONNECT', 3);
    SelectInterest$Companion_getInstance();
  }
  var SelectInterest$READ_instance;
  function SelectInterest$READ_getInstance() {
    SelectInterest_initFields();
    return SelectInterest$READ_instance;
  }
  var SelectInterest$WRITE_instance;
  function SelectInterest$WRITE_getInstance() {
    SelectInterest_initFields();
    return SelectInterest$WRITE_instance;
  }
  var SelectInterest$ACCEPT_instance;
  function SelectInterest$ACCEPT_getInstance() {
    SelectInterest_initFields();
    return SelectInterest$ACCEPT_instance;
  }
  var SelectInterest$CONNECT_instance;
  function SelectInterest$CONNECT_getInstance() {
    SelectInterest_initFields();
    return SelectInterest$CONNECT_instance;
  }
  function SelectInterest$Companion() {
    SelectInterest$Companion_instance = this;
  }
  Object.defineProperty(SelectInterest$Companion.prototype, 'AllInterests', {
  configurable: true, 
  get: function() {
  return SelectInterest$values();
}});
  SelectInterest$Companion.$metadata$ = {
  kind: Kind_OBJECT, 
  simpleName: 'Companion', 
  interfaces: []};
  var SelectInterest$Companion_instance = null;
  function SelectInterest$Companion_getInstance() {
    SelectInterest_initFields();
    if (SelectInterest$Companion_instance === null) {
      new SelectInterest$Companion();
    }
    return SelectInterest$Companion_instance;
  }
  SelectInterest.$metadata$ = {
  kind: Kind_CLASS, 
  simpleName: 'SelectInterest', 
  interfaces: [Enum]};
  function SelectInterest$values() {
    return [SelectInterest$READ_getInstance(), SelectInterest$WRITE_getInstance(), SelectInterest$ACCEPT_getInstance(), SelectInterest$CONNECT_getInstance()];
  }
  SelectInterest.values = SelectInterest$values;
  function SelectInterest$valueOf(name) {
    switch (name) {
      case 'READ':
        return SelectInterest$READ_getInstance();
      case 'WRITE':
        return SelectInterest$WRITE_getInstance();
      case 'ACCEPT':
        return SelectInterest$ACCEPT_getInstance();
      case 'CONNECT':
        return SelectInterest$CONNECT_getInstance();
      default:
        throwISE('No enum constant io.ktor.network.selector.SelectInterest.' + name);
    }
  }
  SelectInterest.valueOf_61zpoe$ = SelectInterest$valueOf;
  function connect(selector, networkAddress, socketOptions, continuation) {
    throw IllegalStateException_init('TCP sockets are unsupported on js platform'.toString());
  }
  function bind(selector, localAddress, socketOptions) {
    throw IllegalStateException_init('TCP sockets are unsupported on js platform'.toString());
  }
  function SocketTimeoutException(message) {
    IOException_init(message, this);
    this.name = 'SocketTimeoutException';
  }
  SocketTimeoutException.$metadata$ = {
  kind: Kind_CLASS, 
  simpleName: 'SocketTimeoutException', 
  interfaces: [IOException]};
  function connectUDP($receiver, selector, remoteAddress, localAddress, options) {
    throw IllegalStateException_init('UDP sockets are unsupported on JS platform'.toString());
  }
  function bindUDP($receiver, selector, localAddress, options) {
    throw IllegalStateException_init('UDP sockets are unsupported on JS platform'.toString());
  }
  var package$io = _.io || (_.io = {});
  var package$ktor = package$io.ktor || (package$io.ktor = {});
  var package$network = package$ktor.network || (package$ktor.network = {});
  var package$selector = package$network.selector || (package$network.selector = {});
  package$selector.ClosedChannelCancellationException = ClosedChannelCancellationException;
  var package$sockets = package$network.sockets || (package$network.sockets = {});
  package$sockets.aSocket_rh7jnd$ = aSocket;
  package$sockets.SocketBuilder = SocketBuilder;
  package$sockets.tcpNoDelay_z3cuth$ = tcpNoDelay;
  package$sockets.Configurable = Configurable;
  Object.defineProperty(package$sockets, 'MAX_DATAGRAM_SIZE_8be2vx$', {
  get: function() {
  return MAX_DATAGRAM_SIZE;
}});
  package$sockets.Datagram = Datagram;
  package$sockets.DatagramWriteChannel = DatagramWriteChannel;
  package$sockets.DatagramReadChannel = DatagramReadChannel;
  package$sockets.DatagramReadWriteChannel = DatagramReadWriteChannel;
  package$sockets.BoundDatagramSocket = BoundDatagramSocket;
  package$sockets.ConnectedDatagramSocket = ConnectedDatagramSocket;
  Object.defineProperty(package$sockets, 'INFINITE_TIMEOUT_MS_8be2vx$', {
  get: function() {
  return INFINITE_TIMEOUT_MS;
}});
  SocketOptions.AcceptorOptions = SocketOptions$AcceptorOptions;
  SocketOptions.PeerSocketOptions = SocketOptions$PeerSocketOptions;
  SocketOptions.UDPSocketOptions = SocketOptions$UDPSocketOptions;
  SocketOptions.TCPClientSocketOptions = SocketOptions$TCPClientSocketOptions;
  Object.defineProperty(SocketOptions, 'Companion', {
  get: SocketOptions$Companion_getInstance});
  package$sockets.SocketOptions = SocketOptions;
  package$sockets.ASocket = ASocket;
  package$sockets.get_isClosed_sl1vcz$ = get_isClosed;
  package$sockets.awaitClosed_sl1vcz$ = awaitClosed;
  package$sockets.AConnectedSocket = AConnectedSocket;
  package$sockets.ABoundSocket = ABoundSocket;
  package$sockets.Acceptable = Acceptable;
  package$sockets.AReadable = AReadable;
  package$sockets.AWritable = AWritable;
  package$sockets.ReadWriteSocket = ReadWriteSocket;
  package$sockets.openReadChannel_pxwuqi$ = openReadChannel;
  package$sockets.openWriteChannel_tl306n$ = openWriteChannel;
  package$sockets.Socket = Socket;
  package$sockets.ServerSocket = ServerSocket;
  package$sockets.Connection = Connection;
  package$sockets.connection_xf5svg$ = connection;
  package$sockets.TcpSocketBuilder = TcpSocketBuilder;
  Object.defineProperty(TypeOfService, 'Companion', {
  get: TypeOfService$Companion_getInstance});
  package$sockets.TypeOfService_init_za3lpa$ = TypeOfService_init;
  package$sockets.TypeOfService = TypeOfService;
  Object.defineProperty(UDPSocketBuilder, 'Companion', {
  get: UDPSocketBuilder$Companion_getInstance});
  package$sockets.UDPSocketBuilder = UDPSocketBuilder;
  package$selector.Selectable = Selectable;
  package$selector.SelectorManager_1fupul$ = SelectorManager;
  Object.defineProperty(SelectorManager_0, 'Companion', {
  get: SelectorManager$Companion_getInstance});
  package$selector.SelectorManager = SelectorManager_0;
  Object.defineProperty(SelectInterest, 'READ', {
  get: SelectInterest$READ_getInstance});
  Object.defineProperty(SelectInterest, 'WRITE', {
  get: SelectInterest$WRITE_getInstance});
  Object.defineProperty(SelectInterest, 'ACCEPT', {
  get: SelectInterest$ACCEPT_getInstance});
  Object.defineProperty(SelectInterest, 'CONNECT', {
  get: SelectInterest$CONNECT_getInstance});
  Object.defineProperty(SelectInterest, 'Companion', {
  get: SelectInterest$Companion_getInstance});
  package$selector.SelectInterest = SelectInterest;
  package$sockets.connect_nzzg24$ = connect;
  package$sockets.bind_7kzecn$ = bind;
  package$sockets.SocketTimeoutException = SocketTimeoutException;
  package$sockets.connectUDP_q3myw$ = connectUDP;
  package$sockets.bindUDP_ytkioc$ = bindUDP;
  SocketBuilder.prototype.configure_ahbkwy$ = Configurable.prototype.configure_ahbkwy$;
  DatagramReadWriteChannel.prototype.receive = DatagramReadChannel.prototype.receive;
  DatagramReadWriteChannel.prototype.send_wa0s53$ = DatagramWriteChannel.prototype.send_wa0s53$;
  BoundDatagramSocket.prototype.dispose = ASocket.prototype.dispose;
  BoundDatagramSocket.prototype.receive = DatagramReadWriteChannel.prototype.receive;
  BoundDatagramSocket.prototype.send_wa0s53$ = DatagramReadWriteChannel.prototype.send_wa0s53$;
  ReadWriteSocket.prototype.dispose = ASocket.prototype.dispose;
  ConnectedDatagramSocket.prototype.dispose = ASocket.prototype.dispose;
  ConnectedDatagramSocket.prototype.receive = DatagramReadWriteChannel.prototype.receive;
  ConnectedDatagramSocket.prototype.send_wa0s53$ = DatagramReadWriteChannel.prototype.send_wa0s53$;
  Acceptable.prototype.dispose = ASocket.prototype.dispose;
  Socket.prototype.dispose = ReadWriteSocket.prototype.dispose;
  ServerSocket.prototype.dispose = ASocket.prototype.dispose;
  TcpSocketBuilder.prototype.configure_ahbkwy$ = Configurable.prototype.configure_ahbkwy$;
  UDPSocketBuilder.prototype.configure_ahbkwy$ = Configurable.prototype.configure_ahbkwy$;
  MAX_DATAGRAM_SIZE = 65535;
  INFINITE_TIMEOUT_MS = Long$Companion$MAX_VALUE;
  Kotlin.defineModule('ktor-ktor-network-jsLegacy', _);
  return _;
}));
